// #autoload
// #name = TeamCommanderHud
// #version = 1.0
// #date = May 20, 2002
// #author = MrBigglesWorth
// #warrior =  MoHaTNaS_GHaNDi
// #email = BobDole@aol.com
// #web = www.lagless.net
// #description = Makes it easy to assign positions to your team
// #status = beta

// ---- Gets You Id, Name, and Player when you join a server for later use
function TCGetMyClientID(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid) {

	if(StrStr(%msgString, "Welcome to Tribes") != -1) {
		$CurrentClientId = %clientId;
	}
}

// ---- Fills player list when you join team or adds player when switches teams

function TCUpdateTeamInfo(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
{
  if(%ClientId $= $CurrentClientId)
    $CurrentTeamId = %TeamId;
    
  // Clearing List since we are the ones who switched or joined team
  TeamCommanderNamesList.clear();
  $TeamCommanderCounter = 0;
    
  // Adding all those who joined before us to the commander list
  %i = 0;
  while((%obj = PlayerListGroup.getObject(%i)) != -1)
  {
    echo("CHECKING ON: " @ %obj.name);
    TCUpdatePlayerInfo(%obj.clientId);
    %i++;
  }
}

// ---- Function that adds the players to team

function TCUpdatePlayerInfo(%clientId)
{
  %player = $PlayerList[%ClientId];
  if(!IsObject(%player))
    return;

  if(%player.teamId $= $CurrentTeamId)
  {
    TeamCommanderNamesList.addRow($TeamCommanderCounter, %player.name);
    $TeamCommanderCounter++;
  }
}

// ---- Function used in Hud to set person to watch for positions from

function TCUpdateCommanderName()
{
  $MyLeader = $CurrentName;
}

// ---- Tells the person their position if they have you marked as leader

function TCAssignPosition()
{
  commandToServer('TeamMessageSent', "\c5ASSIGNING POSITION: \c6" @ $CurrentPosition @ "\c5 - \c6" @ $CurrentName);

  for(%i = 0; %i < $AssignedCounter; %i++)
  {
    if(getWord(TeamCommanderAssignedList.getRowTextById(%i), 0) $= $CurrentName)
      TeamCommanderAssignedList.removeRowById(%i);
  }

  TeamCommanderAssignedList.addRow($AssignedCounter, $CurrentName @ " - " @ $CurrentPosition);
  $AssignedCounter++;
}

// ---- pops up the TeamCommanderHud

function TeamCommanderToggle(%val)
{
  if(%val)
    canvas.pushDialog(TeamCommanderHud);
}

// ---- Sets your position hud visible or invisible

function PositionHudToggle(%val)
{
  if(%val)
  {
    if(TeamCommanderPositionHud.Visible)
      TeamCommanderPositionHud.setVisible(false);
    else
      TeamCommanderPositionHud.setVisible(true);
  }
}

// ---- updates info when you select name on commander hud

function TeamCommanderNamesList::OnSelect(%this, %text, %id)
{
  $CurrentName = %id;
}

// ---- updates info when you select position on commander hud

function TeamCommanderPositionList::OnSelect(%this, %text, %id)
{
  $CurrentPosition = %id;
}

// ---- Callbacks, keybinds, and TeamMessageFunction to watch for positions

package TeamCommander
{
  function OptionsDlg::onWake( %this )
  {
	if(!$TeamCommanderBind) {
		$RemapName[$RemapCount]="Team Commander";
		$RemapCmd[$RemapCount]="TeamCommanderToggle";
		$RemapCount++;
  
		$RemapName[$RemapCount]="Position Hud";
		$RemapCmd[$RemapCount]="PositionHudToggle";
		$RemapCount++;
		$TeamCommanderBind = true;
   }
	parent::onWake(%this);
  }

  function playGui::onWake(%this)
  {
    parent::onWake(%this);
    createMyPositionHud();
    TeamCommanderPositionList.addrow(0, "Capper");
    TeamCommanderPositionList.addrow(1, "LightOffense");
    TeamCommanderPositionList.addrow(2, "Raper");
    TeamCommanderPositionList.addrow(3, "Deployer");
    TeamCommanderPositionList.addrow(4, "HeavyOffense");
    TeamCommanderPositionList.addrow(5, "MidField");
    TeamCommanderPositionList.addrow(6, "FlagDefense");
    TeamCommanderPositionList.addrow(7, "Chaser");
    TeamCommanderPositionList.addrow(8, "HeavyDefense");
    TeamCommanderPositionList.addrow(9, "Shriker");
    TeamCommanderPositionList.addrow(10, "Tanker");
    TeamCommanderPositionList.addrow(11, "Bomber");
  }
  
  function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
  {
    if(StrStr(%msgString, "ASSIGNING POSITION: ") != -1)
    {
      %i = 0;
      while(getWord(%msgString, %i) !$= "POSITION:")
        %i++;

      %newMsg = getWord(%msgString, %i+1) @ " " @ getWord(%msgString, %i+2) @ " " @ getWord(%msgString, %i+3);
      echo(%newMsg);
      
      if(($PlayerList[%sender].name $= $MyLeader) && (StrStr(%newMsg, $PlayerList[$CurrentClientId].name)) != -1)
      {
        $MyPosition = getWord(%msgString, %i+1);
        TeamCommanderPositionText.setText($MyPosition);
      }
    }
      parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
  }
  
  function DispatchLaunchMode()
  {
     addMessageCallback('MsgClientJoin', TCGetMyClientID);
     addMessageCallback('MsgClientJoinTeam', TCUpdateTeamInfo);
     addMessageCallback('MsgClientDrop', TCUpdateTeamInfo);
     parent::DispatchLaunchMode();
  }
};
activatePackage(TeamCommander);

$TeamCommanderCounter = 0;
$AssignedCounter = 0;
$TeamCommanderBind = false;

// ---- Position Hud Creater

function createMyPositionHud()
{
  if(!isObject(TeamCommanderPositionHud))
  {
 	  new ShellFieldCtrl(TeamCommanderPositionHud) {
	  	profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "222 239";
		extent = "110 20";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new GuiTextCtrl(TeamCommanderPositionText) {
			profile = "ShellTextCenterProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "110 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "PositionName";
			longTextBuffer = "0";
			maxLength = "255";
		};
      };

    if(!playGui.isMember(TeamCommanderPositionHud))  playGui.add(TeamCommanderPositionHud);
    if(isObject(HM) && isObject(HudMover))
      Hudmover::AddHud(TeamCommanderPositionHud, "Position Hud");
  }
}

// ---- Gui Crap for the TeamCommanderHud

new GuiControl(TeamCommanderHud) {
	profile = "DlgBackProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "12 128";
		extent = "620 224";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Team Commander";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellFieldCtrl() {
			profile = "GuiChatBackProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 33";
			extent = "384 131";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellScrollCtrl() {
				profile = "NewScrollCtrlProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 2";
				extent = "193 128";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				willFirstRespond = "1";
				hScrollBar = "alwaysOff";
				vScrollBar = "dynamic";
				constantThumbHeight = "0";
				defaultLineHeight = "15";
				childMargin = "3 3";
				fieldBase = "gui/shll_field";

				new GuiScrollContentCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "7 7";
					extent = "179 114";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";

					new GuiTextListCtrl(TeamCommanderNamesList) {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "0 0";
						extent = "179 8";
						minExtent = "8 8";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						helpTag = "0";
						enumerate = "0";
						resizeCell = "1";
						columns = "0";
						fitParentWidth = "1";
						clipColumnText = "0";
					};
				};
			};
			new ShellScrollCtrl() {
				profile = "NewScrollCtrlProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "190 2";
				extent = "193 128";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				willFirstRespond = "1";
				hScrollBar = "alwaysOff";
				vScrollBar = "dynamic";
				constantThumbHeight = "0";
				defaultLineHeight = "15";
				childMargin = "3 3";
				fieldBase = "gui/shll_field";

				new GuiScrollContentCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "7 7";
					extent = "179 114";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";

					new GuiTextListCtrl(TeamCommanderPositionList) {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "0 0";
						extent = "179 8";
						minExtent = "8 8";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						helpTag = "0";
						enumerate = "0";
						resizeCell = "1";
						columns = "0";
						fitParentWidth = "1";
						clipColumnText = "0";
					};
				};
			};
		};
		new ShellFieldCtrl() {
			profile = "GuiChatBackProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 167";
			extent = "384 37";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "125 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "TCUpdateCommanderName();";
				helpTag = "0";
				text = "Assign Leader";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "129 0";
				extent = "125 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "TCAssignPosition();";
				helpTag = "0";
				text = "Assign Position";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "258 0";
				extent = "125 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "canvas.popDialog(TeamCommanderHud);";
				helpTag = "0";
				text = "Finished";
				simpleStyle = "0";
			};
		};
		new ShellFieldCtrl() {
			profile = "GuiChatBackProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "407 33";
			extent = "193 171";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellScrollCtrl() {
				profile = "NewScrollCtrlProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "193 173";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				willFirstRespond = "1";
				hScrollBar = "dynamic";
				vScrollBar = "dynamic";
				constantThumbHeight = "0";
				defaultLineHeight = "15";
				childMargin = "0 0";
				fieldBase = "gui/shll_field";

				new GuiScrollContentCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "4 4";
					extent = "185 165";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";

					new GuiTextListCtrl(TeamCommanderAssignedList) {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "0 0";
						extent = "185 8";
						minExtent = "8 8";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						helpTag = "0";
						enumerate = "0";
						resizeCell = "1";
						columns = "0";
						fitParentWidth = "1";
						clipColumnText = "0";
					};
				};
			};
		};
	};
};
